﻿using Infragistics.Windows.Editors;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Interactivity;
using XamComboEditor_sample.ViewModel;

namespace XamComboEditor_sample.Behaviors
{
    public class XamComboEditorBehavior : Behavior<XamComboEditor>
    {
        protected override void OnAttached()
        {
            base.OnAttached();

            AssociatedObject.SelectedItemChanged += AssociatedObject_SelectedItemChanged;
        }

        protected override void OnDetaching()
        {
            base.OnDetaching();

            AssociatedObject.SelectedItemChanged -= AssociatedObject_SelectedItemChanged;
        }

        private void AssociatedObject_SelectedItemChanged(object sender, System.Windows.RoutedPropertyChangedEventArgs<object> e)
        {
            var previousItem = e.OldValue as Item;
            if (previousItem == null)
                return;

            if (previousItem.OldName != null)
            {
                if (MessageBox.Show("The 'Name' of '" + previousItem.OldName + "' Item was modified. Do you accept the changes?", "Changes", MessageBoxButton.YesNo) == MessageBoxResult.Yes)
                {
                    previousItem.OldName = null;
                }
                else
                {
                    previousItem.Name = previousItem.OldName;
                    previousItem.OldName = null;
                    AssociatedObject.SelectedItem = e.OldValue;
                }
            }
        }
    }
}
