﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Input;

namespace XamComboEditor_sample.ViewModel
{
    public class ViewModel : INotifyPropertyChanged
    {
        private ObservableCollection<Item> items;
        public ObservableCollection<Item> Items
        {
            get { return items; }
            set
            {
                items = value;
                NotifyPropertyChanged("Items");
            }
        }

        private Item mySelectedItem;
        public Item MySelectedItem
        {
            get { return mySelectedItem; }
            set
            {
                mySelectedItem = value;
                NotifyPropertyChanged("MySelectedItem");
            }
        }

        private ICommand updateCommand;
        public ICommand UpdateCommand
        {
            get { return updateCommand; }
            set
            {
                updateCommand = value;
                NotifyPropertyChanged("UpdateCommand");
            }
        }

        public ViewModel()
        {
            Items = new ObservableCollection<Item>()
            {
                new Item("Laptop", 1000, 5),
                new Item("Table", 42990, 20),
                new Item("Rope", 009, 0.2),
                new Item("TV", 820, 12),
                new Item("Smartphone", 350, 0.1),
                new Item("Roller skates", 2214, 6.3)
            };

            MySelectedItem = Items[3]; // TV

            UpdateCommand = new RelayCommand(new Action(() =>
            {
                if (MySelectedItem == null)
                    return;

                MySelectedItem.Name = "[Updated]  " + MySelectedItem.Name;
            }));
        }

        #region Notify Property Changed

        public event PropertyChangedEventHandler PropertyChanged;

        private void NotifyPropertyChanged(String info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }
        }

        #endregion // Notify Property Changed 

    }
}
